#ifndef KODOLAS_H
#define KODOLAS_H

typedef struct {
    char encoding_key[26];
    char decoding_key[26];
} coder_t;

typedef char (*coder_function_t)(coder_t *, char);

coder_t *create_coder_from_encoding_key(char* key);
coder_t *create_coder_from_decoding_key(char* key);
char encode(coder_t *coder, char chr);
char decode(coder_t *coder, char chr);
char code(char *key, char chr);
void get_encoding_key(coder_t*, char*);
void get_decoding_key(coder_t*, char*);

#endif
