#include "kodolas.h"

#include <malloc.h>
#include <stdio.h>

int main() {
    coder_t *coder;
    char key[26];
    coder_function_t codefunc = NULL;
    int c;
    c = getchar();
    if (c == 'E' || c == 'e') {
        codefunc = encode;
    } else if (c == 'D' || c == 'd') {
        codefunc = decode;
    } else {
        return 1;
    }
    if (getchar() != ':') {
        return 2;
    }
    if (getchar() != '\n') {
        return 3;
    }
    for (int i = 0; i < 26; ++i) {
        c = getchar();
        if (c == EOF) {
            return 4;
        }
        key[i] = c;
    }
    if (getchar() != '\n') {
        return 5;
    }
    if (key[0] <= 'Z') {
        coder = create_coder_from_decoding_key(key);
    } else {
        coder = create_coder_from_encoding_key(key);
    }
    if (coder == NULL) {
        return 6;
    }
    while ((c = getchar()) != EOF) {
        putchar(codefunc(coder, c));
    }
    return 0;
}
